/**
 Generarea partitziilor unui numar natural
(<=>vectori de nr. naturale nenule care insumate dau numarul)
Ex:
n=4
1 1 1 1
1 1 2
1 2 1
1 3
2 1 1
2 2
3 1
4

Analiza:
  1) Shirul de solutzii : e clar, generam direct in el
    Spre deosebire de permutari, NU toate solutziile au aceeashi
    lungime
     domenii:
         x[1] apartzine de la 1..n
         x[2] -> 1..n-1
         x[3] -> 1..n-2
         ..
         x[k] -> 1..n-k+1

  2) Valid: x[1]+...+x[k]<=n

  3) Solutzie: x[1]+...+x[k]==n

  4) Fara prelungire
*/
#include <iostream>
using namespace std;

int x[30],n;

int suma(int k)
{
    int s=0;
    while(k)s+=x[k--];
    return s;
}

int afish(int k)
{
    for(int i=1;i<=k;i++)
      cout<<x[i]<<" ";
    cout<<"\n";
}

void back(int k)
{
    int tz;
    for(x[k]=1;x[k]<=n-k+1;x[k]++)
        if((tz=suma(k))<=n)
            if(tz==n)
                afish(k);
            else
                back(k+1);
}

int main()
{
    cin>>n;
    back(1);
    return 0;
}
