/**
 Problema celor n regine:
  Pe o tabla de shah n x n se cere sa se plaseze n regine
a.i. sa NU se atace intre ele.

 Analiza problema:
  1) Shirul de solutzii va reprezenta o codificare a pozitziilor unor
regine pe tabla de shah.
  Shi anume, pleknd de la observatzia ca NU putem avea 2 regine pe
aceeashi linie, vom plasa doar cite una, shi pentru fiecare retzinem
coloana pe care se afla, adik
     x[k] = pozitzia reginei din linia k.
Ex:
+---+---+---+---+
|   | Q |   |   |   2
+---+---+---+---+
|   |   |   | Q |   4
+---+---+---+---+          => vectorashul (2,4,1,3)
| Q |   |   |   |   1
+---+---+---+---+
|   |   | Q |   |   3
+---+---+---+---+

  Domenii:
      x[k] apartzine 1..n

 2) Valid: dama k (proaspat pusa pe tabla) tre' sa NU se atace
        cu vreuna dintre cele k-1 de dinaintea sa.

Cond. ca o dama pusa pe linia k sa se atace cu o dama pusa pe
linia i, cu i<k este urmatoarea:
   x[k]==x[i] || abs(x[k]-x[i])==k-i

 3) Solutzie : k==n

 4) Fara prelungire

*/
#include <iostream>
#include <iomanip>
#include <stdlib.h>
#include<fstream>
using namespace std;

int x[30],n,nrs;
ofstream fout("cici.html");

void afish()
{
    nrs++;
    fout<<"Sol "<<setw(3)<<nrs<<" :<br>";
    fout<<"<table border=\"1\" cellspacing=\"0\">";
    int i,j;
    for(i=1;i<=n;i++)
    {
        fout<<"<tr height=\"40\">";
        for(j=1;j<=n;j++)
        {
            fout<<"<td width=\"40\" align=\"center\" valign=\"middle\"";
            if((i+j)%2)
                fout<<" bgcolor=\"cyan\">";
            else
                fout<<" bgcolor=\"yellow\">";
            if(x[i]==j)
                fout<<"<font size=\"4\">Q</font>";
            else
                fout<<"&nbsp;";
        }
    }
    fout<<"</table><br><br>";
}

int valid(int k)
{
    for(int i=1;i<k;i++)
      if(x[k]==x[i]||abs(x[k]-x[i])==k-i)
            return 0;
    return 1;
}

void back(int k)
{
    for(x[k]=1;x[k]<=n;x[k]++)
        if(valid(k))
            if(k==n)
                afish();
            else
                back(k+1);
}

int main()
{
    cin>>n;
    fout<<"<body><h1>Problema celor "<<n<<" regine pe tabla "<<n<<
        " x "<<n<<" </h1>";
    back(1);
    fout.close();
    system("cici.html");
    return 0;
}
