/**
School: National College Andrei Saguna
First, LAST Name: Alexandru GHITA
Intermediate 3, Contest #3
Input File: chess.in
Output File: chess.out
**/

#include <fstream>
#define Number_Of_Queens 2
#define Board_Size 8

using namespace std;

ifstream fin("chess.in");
ofstream fout("chess.out");

struct Coordinate
{
    int X, Y;
};

void Read();
void Find_Safe_Locations();
void Print();

int Board[Board_Size + 1][Board_Size + 1], N, Safe_Locations,
    MoveX[8] = {-1, -1, 0, 1, 1, 1, 0, -1},
    MoveY[8] = {0, 1, 1, 1, 0, -1, -1, -1};

Coordinate Queen[Number_Of_Queens + 1];

void Read()
{
    for (int i = 1; i <= Number_Of_Queens; i++)
    {
        fin >> Queen[i].X >> Queen[i].Y;
        Board[Queen[i].X][Queen[i].Y] = 1;
    }
    fin >> N;
}

void Find_Safe_Locations()
{
    Coordinate Current;
    Safe_Locations = 64;
    for (int i = 1; i <= Number_Of_Queens; i++)
    {
        for (int j = 0; j <= 7; j++)
        {
            Current.X = Queen[i].X;
            Current.Y = Queen[i].Y;
            for (int k = 1; k <= N; k++)
            {
                Current.X += MoveX[j];
                Current.Y += MoveY[j];
                if (Current.X >= 1 && Current.X <= Board_Size
                 && Current.Y >= 1 && Current.Y <= Board_Size)
                {
                    Board[Current.X][Current.Y] = 1;
                }
            }
        }
    }
    for (int i = 1; i <= Board_Size; i++)
    {
        for (int j = 1; j <= Board_Size; j++)
        {
            if (Board[i][j])
            {
                Safe_Locations--;
                Board[i][j] = 0;
            }
        }
    }
}

void Print()
{
    fout << Safe_Locations << "\n";
}

int main()
{
    for (int line = 1; line <= 5; line++)
    {
        Read();
        Find_Safe_Locations();
        Print();
    }
    fin.close();
    fout.close();
    return 0;
}
